## ros-indigo-canopen-402 0.6.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(canopen_402)

find_package(catkin REQUIRED
  COMPONENTS
    canopen_master
    class_loader
)

find_package(Boost REQUIRED
)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    canopen_402
  CATKIN_DEPENDS
    canopen_master
  DEPENDS
    Boost
)

include_directories(
  include
  ${Boost_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
)

# canopen_402
add_library(canopen_402
  src/motor.cpp
)
target_link_libraries(canopen_402
  ${catkin_LIBRARIES}
)

# canopen_402_plugin
add_library(canopen_402_plugin
  src/plugin.cpp
)
target_link_libraries(canopen_402_plugin
   ${catkin_LIBRARIES}
   canopen_402
)

install(
  TARGETS
    canopen_402
    canopen_402_plugin
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)
install(
  FILES
    canopen_402_plugin.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

if(CATKIN_ENABLE_TESTING)
  catkin_add_gtest(${PROJECT_NAME}-test_clamping
    test/clamping.cpp
  )
  target_link_libraries(${PROJECT_NAME}-test_clamping
    ${catkin_LIBRARIES}
  )
endif()

=== debian/changelog ===
ros-indigo-canopen-402 (0.6.9-0trusty) trusty; urgency=high

  * fix initialization bug in ProfiledPositionMode
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 22 May 2018 22:00:00 -0000

ros-indigo-canopen-402 (0.6.8-0trusty) trusty; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 17 Jul 2017 22:00:00 -0000

ros-indigo-canopen-402 (0.6.7-0trusty) trusty; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 27 Mar 2017 22:00:00 -0000

ros-indigo-canopen-402 (0.6.6-0trusty) trusty; urgency=high

  * do quickstop for halt only if operation is enabled
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 17 Mar 2017 23:00:00 -0000

ros-indigo-canopen-402 (0.6.5-0trusty) trusty; urgency=high

  * stop on internal limit only if limit was not reached before
  * hardened code with the help of cppcheck
  * Do not send control if it was not changed
    Otherwise invalid state machine transitions might get commanded
  * styled and sorted CMakeLists.txt
    * removed boilerplate comments
    * indention
    * reviewed exported dependencies
  * styled and sorted package.xml
  * update package URLs
  * added option to turn off mode monitor
  * reset Fault_Reset bit in output only
  * enforce rising edge on fault reset bit on init and recover
  * Revert "Enforce rising edge on fault reset bit on init and recover"
  * enforce rising edge on fault reset bit on init and recover
  * Merge pull request #117 <https://github.com/ipa-mdl/ros_canopen/issues/117> from ipa-mdl/condvars
    Reviewed condition variables
  * use boost::numeric_cast for limit checks since it handles 64bit values right
  * add clamping test
  * enforce target type limits
  * ModeTargetHelper is now template
  * readability fix
  * simplified State402::waitForNewState and Motor402::switchState
  * Set Halt bit unless current mode releases it
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 09 Dec 2016 23:00:00 -0000

ros-indigo-canopen-402 (0.6.4-0trusty) trusty; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 02 Jul 2015 22:00:00 -0000

ros-indigo-canopen-402 (0.6.3-0trusty) trusty; urgency=high

  * improved PP mode
  * do not quickstop in fault states
  * do not diable selected mode on recover, just restart it
  * initialize to No_Mode
  * removed some empty lines
  * implemented support for mode switching in a certain 402 state, defaults to Operation_Enable
  * pass LayerStatus to switchMode
  * remove enableMotor, introduced switchState
  * added motor_layer settings
  * fixed PP mode
  * explicit find for class_loader
  * fail-safe setting of op_mode to No_Mode
  * Improved behaviour of concurrent commands
  * added alternative Transitions 7 and 10 via Quickstop
  * added alternative success condition to waitForNewState
  * make motor init/recover interruptable
  * changed maintainer
  * removed SM-based 402 implementation
  * added Motor402 plugin
  * added new 402 implementation
  * added MotorBase
  * Added validity checks
  * Removed overloaded functions and makes the handle functions protected
  * Removes test executable
  * Removes unnecessary configure_drive and clears the set Targets
  * Some position fixes
  * Removed timeout
    Reduced recover trials
  * Removes some logs
  * Homing integrated
  * handleRead, handleWrite fixes
  * Merge remote-tracking branch 'mdl/indigo_dev' into refactor_sm
    Conflicts:
    canopen_402/include/canopen_402/canopen_402.h
    canopen_402/src/canopen_402/canopen_402.cpp
    canopen_motor_node/src/control_node.cpp
  * Moved supported_drive_modes to ModeSpecificEntries
  * 
    
      * Init, Recover, Halt for SCHUNK
      * Removed sleeps from the state machine
      * Now works as reentrant states
    
  * refactored Layer mechanisms
  * Recover failure
  * Merge remote-tracking branch 'mdl/indigo_dev' into refactor_sm
    Conflicts:
    canopen_402/include/canopen_402/canopen_402.h
    canopen_402/src/canopen_402/canopen_402.cpp
  * Removing some unnecessary couts
  * First version with Recover
    * Tested on SCHUNK LWA4D
  * Initializing all modules at once
  * Moving SCHUNK using the IP mode sub-state machine
  * Schunk does not set operation mode via synchronized RPDO
  * initialize homing_needed to false
  * Working with the guard handling and some scoped_locks to prevent unwanted access
  * Passing ``state_`` to motor machine
  * Fixes crash for unitialized boost pointer for ``target_vel_`` and ``target_pos_``
  * Thread running
  * Separates the hw with the SM test
    Advance on the Mode Switching Machine
  * Organizing IPMode State Machine
  * Adds mode switch and a pre-version of the turnOn sequence
  * Event argument passed to the Motor state machine
  * Adds the internal actions
  * Control_word is set from motor state machine
  * Motor abstraction on higher level machine
    Some pointers organization
  * 
    
      * Begins with the Higher Level Machine
      * Separates the status and control from the 402 node
    
  * Ip mode sub-machine
  * Organizing the status and control machine
  * do not read homing method if homing mode is not supported
  * inti ``enter_mode_failure_`` to false
  * require message strings for error indicators, added missing strings, added ROS logging in sync loop
  * Merge pull request #75 <https://github.com/ros-industrial/ros_canopen/issues/75> from mistoll/indigo_release_candidate
    Move ip_mode_sub_mode to configureModeSpecificEntries
  * Fixed tabs/spaces
  * bind IP sub mode only if IP is supported
  * Move ip_mode_sub_mode to configureModeSpecificEntries
  * Update state_machine.h
  * Ongoing changes for the state machine
  * 
    
      * Eliminates Internal State conflict
      * Treats exceptions inside the state machine
    
  * Cleaning the 402.cpp file
  * Test file
  * Adds state machine definition


=== debian/control ===
Source: ros-indigo-canopen-402
Section: misc
Priority: extra
Maintainer: Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-canopen-master, ros-indigo-catkin, ros-indigo-class-loader, ros-indigo-rosunit
Homepage: http://wiki.ros.org/canopen_402
Standards-Version: 3.9.2

Package: ros-indigo-canopen-402
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-canopen-master, ros-indigo-class-loader
Description: This implements the CANopen device profile for drives and motion control.
 CiA(r) 402

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-canopen-402//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
